<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Weekenddetector App</title>
    <style>
        * {
            margin: 0;
            padding: 0;
            font-family: Calibri;
        }

        body,
        html {
            width: 100%;
            height: 100%;
        }

        #wrapper {
            width: 100%;
            height: 100%;
            display: flex;
            justify-content: center;
            align-items: center;
            flex-wrap: wrap;
        }

        .warning-message {
            color: crimson;
            font-size: 2em;
            font-weight: bold;
            flex: 100%;
            text-align: center;
        }

        .ok-message {
            color: darkgreen;
            font-size: 2em;
            font-weight: normal;
            flex: 100%;
            text-align: center;
        }

        .click-counter {
            color: darkslateblue;
            border: 1px solid darkslateblue;
            margin: 50px;
            flex: 100%;
            text-align: center;
        }
    </style>
</head>

<body>
    <div id="wrapper">
        <div class="ok-message" style="display: none;">
            On töönädal, tööta rahus edasi!
        </div>
        <div class="warning-message" style="display: none;">
            Nädalavahetus, töötamine keelatud!
        </div>
        <div class="click-counter">
            0
        </div>
    </div>
    <script>

        function getCurrentDateTime() {
            let currentDateTime = new Date();
            let year = currentDateTime.getFullYear();
            let month = currentDateTime.getMonth() + 1;
            month = month < 10 ? "0" + month : month;
            let day = currentDateTime.getDate();
            day = day < 10 ? "0" + day : day;
            let hour = currentDateTime.getHours();
            hour = hour < 10 ? "0" + hour : hour;
            let minute = currentDateTime.getMinutes();
            minute = minute < 10 ? "0" + minute : minute;
            let dateStr = `${year}-${month}-${day} ${hour}:${minute}`;
            return dateStr;
        }

        async function getWeekendStatus(dateStr) {
            let url = `http://localhost:8080/weekenddetector`;
            let form = new FormData();
            form.append("date", dateStr);
            let conf = {
                method: 'POST',
                body: form
            };
            let response = await fetch(url, conf);
            let status = await response.text();
            return status;
        } 

        async function registerVisitAndGetCount() {
            let url = 'http://localhost:8080/visits/register_event_denoting_user_visit';
            await fetch(url);

            url = 'http://localhost:8080/visits/give_me_visit_count';
            let response = await fetch(url);
            let visitCount = await response.text();
            return visitCount;
        }

        async function doDisplayWeekendStatus() {
            let currentDateStr = getCurrentDateTime();
            let isItWeekend = await getWeekendStatus(currentDateStr);
            if(isItWeekend == 'true') {
                document.querySelector('#wrapper .warning-message').style.display = 'block';
                document.querySelector('#wrapper .ok-message').style.display = 'none';
            } else {
                document.querySelector('#wrapper .warning-message').style.display = 'none';
                document.querySelector('#wrapper .ok-message').style.display = 'block';
            }
        }

        async function doRegisterAndGetCount() {
            let visitCount = await registerVisitAndGetCount();
            document.querySelector('#wrapper .click-counter').innerText = visitCount;
        }

        doRegisterAndGetCount();
        doDisplayWeekendStatus();
    </script>
</body>

</html>